var expander;
var chartVanisher;
var blinker = null;

var elem_arrow;
var elem_chart;

function errorHandler(error) {
    showStatus( error );
}

function diminishArrow( exp ) {
    var opacity;
    if ( exp.isCollapsed == false ) {
        opacity = 1.0 - exp.counter / exp.steps;
    } else {
        opacity = exp.counter / exp.steps;
    }
    elem_arrow.style.opacity = opacity;
}

function initialize() {
    var element = document.getElementById( 'container' );
    expander = new Expander( element );
    expander.setInterval( 13 );
    expander.setSteps( 5 );
    expander.setSize( 450, 150, 450, 400 );
    expander.addListener( diminishArrow );
    
    chartVanisher = new DisappearableObject( document.getElementById('chart' ) );
    chartVanisher.setOpacity( 0, 1 );
    chartVanisher.interval = 13;
    elem_arrow = document.getElementById( 'arrow' );
    elem_chart = document.getElementById( 'chart' );


    blinker = new BlinkContoller( document.getElementById( "status" ) );
}

function pushArrow(event) {
    if ( expander.isRunning || chartVanisher.isRunning ) return;
    if ( expander.isCollapsed ) {
      var callback = function(obj) { 
          obj.endHandler = null;
          elem_chart.style.zIndex = 0;
          expander.expand(); 
      }
      expander.endHandler = null; 
      chartVanisher.endHandler = callback;
      chartVanisher.transit();
    } else {
        var callback = function(obj) { 
            obj.endHandler = null;
            chartVanisher.transit(); 
        };
        elem_chart.style.zIndex = 200;
        chartVanisher.endHandler = null;
        expander.endHandler = callback;
        expander.expand();
    }
}



function showStatus( message ) {
    var elem = document.getElementById( "status" );
    if ( elem ) {
        elem.innerText = message;// + ": " + window.outerHeight;
    }
}

function replaceIcon( id, source ) {
    var elem = document.getElementById( id );
    if ( elem ) {
        elem.src = source;
    }
}

var __hexstring = "0123456789ABCDEF";
function __getHex( num ) {
    var div = parseInt( num / 16 );
    var rem = num - div * 16;
    if ( div < 0 ) div = 0;
    if ( div > 15 ) div = 15;
    if ( rem < 0 ) rem = 0;
    if ( rem > 15 ) rem = 15;
    return __hexstring.charAt( div ) + __hexstring.charAt( rem );
}

var url_original = null;
var code_retried = "";
var command = null;

var timer = null;

function BlinkContoller( element ) {
    this.statusElement = element;
    this.isBlinking    = false;
    this.counter       = 0;
    this.color         = "#fff";
    this.blinkWait     = 10;
}


function BlinkController_setColor( blinker ) {
    var counter = blinker.counter;
    var colorname = null;
    if ( counter == 0 ) {
        colorname = "white";
    } else {
        var grayscale = counter % 512;
        if ( grayscale >= 256 ) {
            grayscale = 511 - grayscale;
        }
        var hex = __getHex( 255 - grayscale );
        colorname = "#" + hex + hex + hex;
    }
    blinker.statusElement.style.color = colorname;
    return;
}


function blink() {
    if ( blinker.isBlinking ) {
        blinker.counter += 4;
        BlinkController_setColor( blinker );
        setTimeout( blink, blinker.blinkWait );
    } else {
        blinker.counter = 0;
        BlinkController_setColor( blinker );
        return;
    }
}

var isLoading = false;
var currentCode = null;
var ba_num_loading = 0;
function retrieveData( event ) {
    var elem_code = document.getElementById( "stockcode" );
    if ( window.widget ) {
        if ( isLoading ) {
            if ( command != null ) {
                command.cancel();
                currentCode = null;
            }
        }
        isLoading = true;
        var code = elem_code.value;
        var ba_num = 1;
        if ( baNum ) {
            if ( baNum[ code ] ) {
                ba_num = baNum[ code ];
                ba_num_loading = ba_num;
            }
        }
        currentCode = parseInt( code );
        var url_image = "http://chart.nikkei.co.jp/c/tick/maketick.cgi?STK_CODE=" + code + "&BA_NUM=" + ba_num;
        url_original = "http://company.nikkei.co.jp/index.cfm?scode=" + code;
        document.getElementById( "graph" ).src = url_image;
        pycommand = "/usr/bin/python get_stock_info.py " + code;
        blinker.isBlinking = true;
        setTimeout( blink, 10 );
        command = widget.system( pycommand, endHandler );
        showStatus( "Loading...");
    }
}

var regex_ba = new RegExp( "<!--BA:(\\d+)-->" );

function endHandler( syscommand ) {
    blinker.isBlinking = false;
    if ( command != null ) {
        var output = syscommand.outputString;
        if ( output == "NO CODE\n" ) {
            showStatus( "その株式コードはありません " + document.getElementById( 'stockcode' ).value );
            document.getElementById( "graph" ).src = "Images/no-data.png";
            url_original = null;
        } else if ( output == "CANNOT LOAD\n" ) {
            showStatus( "ロードできませんでした" );
            document.getElementById( "graph" ).src = "Images/no-data.png";
            url_original = null;
        } else if ( output == "" ) {
            showStatus( "Error" );
            url_original = null;
        } else if ( output.length < 20 ) {
            showStatus( "Error '" + output + "'" );
            url_original = null;
        } else {
            var reg_result =  regex_ba.exec( output );
            if ( reg_result ) {
                var ba_num = reg_result[ 1 ];
                if ( ba_num != ba_num_loading ) {
                    var url_image = "http://chart.nikkei.co.jp/c/tick/maketick.cgi?STK_CODE=" + currentCode + "&BA_NUM=" + ba_num;
                    document.getElementById( "graph" ).src = url_image;
                }
            }
            document.getElementById( "stockinformation" ).innerHTML = output;
            showStatus( "" );
            //showStatus( "Data loaded" );
        }
        command = null;
    }
    isLoading = false;
}

function openBrowser( event ) {
    if ( command != null ) { // running script
        return;
    }
    if ( url_original == null ) {
        showStatus( "No URL specified" );
        return;
    }
    //showStatus( "open " + url_original );
    if ( window ) {
        widget.openURL( url_original );
    }
}

function ExpansionStatus() {
    this.element = document.getElementById( 'container' );
    this.element_bottom = document.getElementById( 'border-bottom' );
    //this.currentHeight = elem.style.height;
    this.isRunning  = false;
    this.isExpanded = false;
    this.minHeight  = 148;
    this.maxHeight  = 356;
    this.step       = 0;
    this.counter    = 0;
    this.headerHeight  = 20;
    this.defaultWindowWidth  = parseInt( window.outerWidth );
    this.defaultWindowHeight = parseInt( window.outerHeight );
    this.ticks      = 8;
    this.chartCount = 0;
    this.chartTicks = 10;
    this.expandWait = 5;
    this.opacityWait = 10;
    this.chart = document.getElementById( "chart" );
    this.arrow = document.getElementById( "arrow" );
}

